//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * タヌーダッシュ攻撃状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Enemy/Tanue/TanueDashAttackState.h"
#include "Game/Sound/SoundSystem.h"
#include "Enemy/System/Enemy.h"
#include "Stage/System/Stage.h"

#include "Enemy/Tanue/TanueRunState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
TanueDashAttackState::TanueDashAttackState(Tanue* tanue) : TanueState(tanue){
}
//------------------------------------------------------------------------------
// デストラクタ
TanueDashAttackState::~TanueDashAttackState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void TanueDashAttackState::initialize(){
	// アニメーションシーケンス設定
	getAnimation()->setSequence(1);
	// 攻撃方向
	attackDirection_ = getPlayerDirection();
	// コリジョンを有効にする
	getAttackCollision()->setEnabled(true);
	// 音を鳴らす
	getSoundSystem()->play("TanueDashAttack");
}
//------------------------------------------------------------------------------
// 後始末
void TanueDashAttackState::finalize(){
	// コリジョンを無効に戻す
	getAttackCollision()->setEnabled(false);
}
//------------------------------------------------------------------------------
// 実行
void TanueDashAttackState::run(){
	// 定数
	float animationScale = 4.f;
	float moveXZScale = 0.6f;

	// ステート変更
	if(!isDamaged()){
		if(getRunCounter() == 90){
			getEnemy()->setState(new TanueRunState(getTanue()));
		}
	}

	// 移動ベクトル算出
	Vector3 moveVelocity = attackDirection_;
	moveVelocity *= moveXZScale;

	// アニメーション速度調整
	animationScale *= moveVelocity.getLength();

	// 位置と速度の計算
	calcVelocityAndPosition(moveVelocity);
	// 向きの設定
	setDirection(moveVelocity);

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);

	// 攻撃
	attackCollide(getBodyBone(), Vector3(0.f, 0.f, 0.f), 8.f, 90);
}
//------------------------------------------------------------------------------
